import java.util.Date;
import java.util.Iterator;


import jade.core.AID;
import jade.core.Agent;
import jade.core.behaviours.*;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;

public class Camarero extends Agent{
	private String Comanda;
	class Habla extends SimpleBehaviour
    {

		private boolean fin = false;
        public void action()
        {

        //Obtiene el primer mensaje de la cola de mensajes
            ACLMessage mensaje = blockingReceive();

            if (mensaje!= null)
            {
                System.out.println(getLocalName() + ": Buenas noches señor desea tomar algo?");
                ACLMessage mensaje2 = new ACLMessage(ACLMessage.REQUEST);
                mensaje2.setSender(getAID());
                AID id=new AID();
                id.setLocalName("Cliente");
                mensaje2.addReceiver(id);
                mensaje2.setContent("Buenas noches señor!, tome asiento");
                send(mensaje2);
                ACLMessage mensaje3=blockingReceive();
                if(mensaje3!=null){
                	ACLMessage mensaje4= new ACLMessage(ACLMessage.REQUEST);
                	mensaje4.setSender(getAID());
                	mensaje4.addReceiver(id);
                	mensaje4.setContent("¿Desea que le aconseje?");
                	System.out.println(getLocalName()+": "+ mensaje4.getContent());
                	send(mensaje4);
                	ACLMessage mensaje5=blockingReceive();
                	if(mensaje5!=null){
                		ACLMessage mensaje6 = new ACLMessage(ACLMessage.INFORM);
         			   mensaje6.setSender(getAID());
         			   mensaje6.addReceiver(id);
         			   mensaje6.setContent("Para menú del día tenemos, de primero: Menestra, Tartar de Atún y Pasta fresca.\n" +
         			   		"De segundo, Merluza en salsa verde, Pimientos rellenos y cordero asado");
         			   System.out.println(getLocalName()+" :"+mensaje6.getContent());
         			  send(mensaje6);
         			  ACLMessage mensaje7=blockingReceive();
         			  if(mensaje7!=null){
         				  Comanda=mensaje7.getContent();
         				  ACLMessage mensaje8= new ACLMessage(ACLMessage.INFORM);
         				  mensaje8.setSender(getAID());
         				  mensaje8.addReceiver(id);
         				  mensaje8.setContent("Perfecto Manolete, ensequida le traen la bebida");
         				  System.out.println(getLocalName()+": "+ mensaje8.getContent());
         				  send(mensaje8);
         			  }
                	}
                }
                fin = true;
            }
        }
        public boolean done()
        {
            return fin;
        }
}
	class ComCocinero extends SimpleBehaviour{
		private boolean fin=false;
		public void action(){
			ACLMessage mensajeCocinero = new ACLMessage(ACLMessage.INFORM);
			AID idCocinero = new AID();
			idCocinero.setLocalName("Cocinero");
			mensajeCocinero.addReceiver(idCocinero);
			mensajeCocinero.setSender(getAID());
			mensajeCocinero.setConversationId("COCINERO");
			mensajeCocinero.setContent(Comanda);
			System.out.println(getLocalName()+": LLEGA COMANDA, COCINA!!");
			send(mensajeCocinero);
			ACLMessage mensajeDe = blockingReceive();
			if (mensajeDe!=null){
				System.out.println(getLocalName()+": Gracias!");
			}
			AID idBarman = new AID();
			idBarman.setLocalName("Barman");
			ACLMessage mensajeBarman = new ACLMessage(ACLMessage.REQUEST);
			mensajeBarman.setSender(getAID());
			mensajeBarman.addReceiver(idBarman);
			mensajeBarman.setContent("Antxon! una caña gigante!");
			System.out.println(getLocalName()+": "+mensajeBarman.getContent());
			send(mensajeBarman);
		fin= true;	
		}
		public boolean done(){
			return fin;
			
		}
	}
	class LlevarPlatos extends CyclicBehaviour{
		MessageTemplate plantilla = null;
		public LlevarPlatos(){
			AID idCocinero = new AID();
			idCocinero.setLocalName("Cocinero");
			MessageTemplate filtroEmisor = MessageTemplate.MatchSender(idCocinero);
			MessageTemplate filtroInform = MessageTemplate.MatchPerformative(ACLMessage.INFORM);
			 plantilla = MessageTemplate.and(filtroInform,filtroEmisor);
			
		}
		public void action() {
			ACLMessage listo = blockingReceive(plantilla);
			if(listo!=null){
				if(listo.getContent().equals("Primero plato listo, camarero!")){
					ACLMessage toCliente = new ACLMessage(ACLMessage.INFORM);
					AID idCliente = new AID();
					idCliente.setLocalName("Cliente");
					toCliente.addReceiver(idCliente);
					toCliente.setSender(getAID());
					toCliente.setContent("Tenga señor, su primer plato");
					System.out.println(getLocalName()+": "+toCliente.getContent());
					send(toCliente);
				}else if(listo.getContent().equals("Segundo plato listo, camarero!")){
					ACLMessage toCliente = new ACLMessage(ACLMessage.INFORM);
					AID idCliente = new AID();
					idCliente.setLocalName("Cliente");
					toCliente.addReceiver(idCliente);
					toCliente.setSender(getAID());
					toCliente.setContent("Tenga señor, su segundo plato");
					System.out.println(getLocalName()+": "+toCliente.getContent());
					send(toCliente);
				}else if(listo.getContent().equals("El postre está listo, camarero!")){
					ACLMessage toCliente = new ACLMessage(ACLMessage.INFORM);
					AID idCliente = new AID();
					idCliente.setLocalName("Cliente");
					toCliente.addReceiver(idCliente);
					toCliente.setSender(getAID());
					toCliente.setContent("Tenga señor, su postre");
					System.out.println(getLocalName()+": "+toCliente.getContent());
					send(toCliente);
				}
			}else{
				System.out.println("Algo va mal");
			}
			
		}
	}
	class Turno extends WakerBehaviour{

		public Turno(Agent a, int wakeupDate) {
			super(a, wakeupDate);
		}

		private static final long serialVersionUID = 1L;
		protected void onWake(){
			System.out.println(getLocalName()+": Terminó mi turno!");
		}
		public int onEnd(){
			System.out.println(getLocalName()+": Me voy a mi casa!");
			myAgent.doDelete();
			return 0;
		}
		
	}

protected void setup()
{
    addBehaviour(new Habla());
    addBehaviour(new ComCocinero());
    addBehaviour(new LlevarPlatos());
   addBehaviour(new Turno(this,800));
}
}